/*
 * Copyright (c) 2015 ezivkoc
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
 * THE SOFTWARE.
 */

package wa.server.page;

import zutil.net.http.HttpHeader;
import zutil.net.http.HttpHeaderParser;
import zutil.net.http.HttpPage;
import zutil.net.http.HttpPrintStream;
import zutil.parser.DataNode;
import zutil.parser.json.JSONWriter;
import zutil.struct.CircularBuffer;

import java.io.IOException;
import java.util.Iterator;
import java.util.Map;
import java.util.logging.Handler;
import java.util.logging.LogRecord;

/**
 * Created by Ziver on 2015-09-22.
 */
public class WALogPage extends Handler implements HttpPage {
    private CircularBuffer<LogRecord> logBuffer;

    @Override
    public void publish(LogRecord record) {
        if(super.isLoggable(record)){
            logBuffer.add(record);
        }
    }


    @Override
    public void flush() {}
    @Override
    public void close() throws SecurityException {
        throw new UnsupportedOperationException ();
    }


    @Override
    public void respond(HttpPrintStream out,
                        HttpHeader client_info,
                        Map<String, Object> session,
                        Map<String, String> cookie,
                        Map<String, String> request) throws IOException {

        DataNode logNode = new DataNode(DataNode.DataType.List);
        Iterator<LogRecord> it = logBuffer.iterator();
        for(int i=0; i<20 && it.hasNext(); ++i){
            LogRecord record = it.next();
            DataNode node = new DataNode(DataNode.DataType.Map);
            node.set("timestamp", record.getMillis());
            node.set("source", record.getLoggerName());
            node.set("msg", record.getMessage());
            logNode.add(node);
        }

        DataNode root = new DataNode(DataNode.DataType.Map);
        root.add(logNode);
        JSONWriter writer = new JSONWriter(out);
        writer.write(root);
        writer.close();
    }
}
